struct SIO
{
	unsigned char	command;
	unsigned int	wave_datnum[64];
	unsigned int	*wave_ptr[48];

	/*g`f[^LGA擪AhXiItCvŽʁj*/
	/*ob⃁Cbot󂯎珑Ȃ*/
	unsigned int	*ram0_arm, *ram0_body;

	/*Đ̃ZbgiW֐߁^S֐߁j̐擪AhX*/
	unsigned int	*ram1_arm, *ram1_body;

	/*g`f[^LGA擪AhXi[Jbotł̌vZʁj*/
	/*̓xɏ*/
	unsigned int	*ram2_arm, *ram2_body;
	/*g`f[^gȂƂ̃f[^LGA擪AhX*/
	unsigned int	*ram_arm_live0, *ram_body_live0;
	unsigned int	adxl_data[2], adxl[2][2], adxl_newtral[2];
	float			body_newtral[3], body_propo_val[3];
};

struct SERVO_DATA
{
	unsigned char	mode;					/*̗L1:LA0:*/
	unsigned char	data_num;				/*f[^*/
	unsigned char	brake_point;			/*u[L|Cg*/
	unsigned int	data0[4][2];			/*o͒̃f[^*/
	unsigned int	data1[4][2];			/*ڕWl*/
	float			data0_f[4][2];			/*[Nϐ*/
	float			direction[4][2];		/**/
	float			brake_flg[4][2];		/*tO*/
	float			v0[4][2];				/*x*/
	float			v_max[4][2];			/*ő呬x*/
	float			a0[4][2];				/*x*/
};

struct SWITCHES
{
	unsigned char	adxl_on, servo_on, debug;
	unsigned char	wave_play_arm, wave_play_body;
	unsigned char	live_play_arm_v, live_play_arm_h;
	unsigned char	live_dir_arm;
	unsigned char	wave_datsum;
};

float sin_r(float in_val);
float cos_r(float in_val);

void generate_signal1(struct SIO *sio, struct SERVO_DATA *servo_data);
void generate_signal2(struct SIO *sio, struct SERVO_DATA *servo_data);
void move_servo(struct SERVO_DATA *servo_data);
void move_head(unsigned char action_com[3], struct SIO *sio, struct SERVO_DATA *servo_data);



void print_iii_sci1(int data);
void print_ii_sci0(unsigned int data);
void print_ii_sci1(unsigned int data);
void print_ii_sci2(unsigned int data);
void print_i_sci1(unsigned char	data);
void print_c_sci2(unsigned char	data);
void print_c_sci1(unsigned char	data);
void print_c_sci0(unsigned char	data);
void print_s_sci1(char string[80]);
unsigned char read_c_sci2(void);
unsigned char read_c_sci1(void);
unsigned char read_c_sci0(void);
unsigned char read_c_sci2b(void);
unsigned char read_c_sci1b(void);
unsigned char read_c_sci0b(void);
unsigned int  read_i_sci1(void);
unsigned int  read_ii_sci1(void);
unsigned int  read_ii_sci1b(void);
unsigned int  read_ii_sci2(void);
void comm_acc(unsigned char debug, unsigned char command);


void init_switches(struct SIO *sio, struct SWITCHES *switches);
void init_main(void);
void wait(unsigned int time);
void wait_val(unsigned int out_data[2]);
void read_adxl(struct SIO *sio);

char sio_comm1(struct SIO *sio, struct SWITCHES *switches
			   , struct SERVO_DATA *servo_data_arm, struct SERVO_DATA *servo_data_body);
char sio_comm2(struct SIO *sio, struct SWITCHES *switches);
