#include <3067F.H>
#include "w6v5b.h"

/*********************************************************************/
void init_switches(struct SIO *sio, struct SWITCHES *switches)
{
	sio->body_newtral[0]		= (float)2200.0;
	sio->body_newtral[1]		= (float)2150.0;
	sio->body_newtral[2]		= (float)2150.0;

	sio->body_propo_val[0]	= (float)23.12;
	sio->body_propo_val[1]	= (float)23.12;
	sio->body_propo_val[2]	= (float)23.12;

	/*ZT[XCb`p̃tO*/
	switches->adxl_on = 1;

	/*qbT[{MXCb`*/
	switches->servo_on = 1;

	switches->wave_play_arm = 0;
	switches->wave_play_body = 0;

	switches->wave_datsum = 1;

	switches->live_play_arm_v = 0;
	switches->live_play_arm_h = 0;

	switches->debug = 0;
}
/*********************************************************************/
void init_main(void)
{
	/*NbNWT*/
	ITU0.TCR.BIT.TPSC = 3;
	/*TW Startt[jO[h*/
	ITU.TSTR.BIT.STR0 = 1;

	/*NbNWT*/
	ITU1.TCR.BIT.TPSC = 3;
	/*TW Startt[jO[h*/
	ITU.TSTR.BIT.STR1 = 1;

	/*NbNWT*/
	ITU2.TCR.BIT.TPSC = 3;
	/*TW Startt[jO[h*/
	ITU.TSTR.BIT.STR2 = 1;

	/**********************************/
	/*A/DRo[^@WX^ݒ*/
	/*XL[h*/
	AD.CSR.BIT.SCAN = 1;
	/*vXe[g134*/
	AD.CSR.BIT.CKS = 0;
	/*0cĥ݌JԂϊ*/
	AD.CSR.BIT.CH = 0;
	/*ϊX^[g*/
	AD.CSR.BIT.ADST = 1;
	/**********************************/
	/*VAC^[tFCX*/
	SCI0.SCR.BYTE	= 0x00;
	SCI0.SMR.BYTE	= 0x00;
	SCI0.BRR		= 32;/*19200 bps*/

	ITU0.TCNT = 0;
	while(ITU0.TCNT < 300);
	SCI0.SCR.BYTE	= 0x30;

	/***************************/
	SCI1.SCR.BYTE	= 0x00;
	SCI1.SMR.BYTE	= 0x00;
	SCI1.BRR		= 32;/*19200 bps*/

	ITU0.TCNT = 0;
	while(ITU0.TCNT < 300);
	SCI1.SCR.BYTE	= 0x30;

	/***************************/
	/*
	*/

	SCI2.SCR.BYTE	= 0x00;
	SCI2.SMR.BYTE	= 0x00;
	SCI2.BRR		= 32;

	ITU0.TCNT = 0;
	while(ITU0.TCNT < 300);
	SCI2.SCR.BYTE	= 0x30;
	/**********************************/
	/**********************************/
	P1DDR = 0xff;
	P2DDR = 0xff;

	P4DDR = 0x00;
	P4PCR.BYTE = 0xff;/*vAbvON*/

	P5DDR = 0xff;
	/*P7͓͐p|[g*/
	P8DDR = 0xff;
	PADDR = 0xff;
	PBDDR = 0x3f;

	P8DR.BIT.B3 = 1;

}

