#include <3067F.H>
#include "w6v5b.h"

char sio_comm1(struct SIO *sio, struct SWITCHES *switches
			   , struct SERVO_DATA *servo_data_arm, struct SERVO_DATA *servo_data_body)
{
unsigned char	i, j;
unsigned char	action_com[3];
unsigned int	ii, jj, sio_buff_i[6];

unsigned int	*ram1, *ram2;

static	int		ist = 0;

	/*eSCI̐ڑ
	OFNo.1@TuCPU
	PFPC
	QFCCPU
	*/

	/*
	switches->debug = 0	:@Cbot@@@@ƒʐM
	switches->debug = 1	:@ob̂uavOƒʐM
	*/

	/*********************************************************************/
	/**                  No.2TuCPÛ̒ʐM                      **/
	/*********************************************************************/

	/*֐߃f[^󂯎iP֐ߕj*/
	if(sio->command == 'A')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*֐ߔԍM*/
		if(switches->debug == 1)
		{
			j = (unsigned char)read_i_sci1();
			/*f[^M*/
			ii = read_ii_sci1();
		}
		else
		{
			j = read_c_sci2();
			ii = read_ii_sci2();
		}

		ram1 = sio->ram1_arm + j;
		*ram1 = ii;
	}

	/*֐߃f[^󂯎iP|Cgj*/
	if(sio->command == 'B')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		ram1 = sio->ram1_arm;
		ram2 = sio->ram1_body;

		for(j = 0; j < 12; j++)
		{
			if(j < 8)
			{
				if(switches->debug == 1)	*ram1 = read_ii_sci1();
				else						*ram1 = read_ii_sci2();
				ram1++;
			}
			else
			{
				if(switches->debug == 1)	*ram2 = read_ii_sci1();
				else						*ram2 = read_ii_sci2();
				ram2++;
			}
		}
	}

	/*ADXL202̏ԑM*/
	if(sio->command == 'C')
	{
		/*print_s_sci1("ADXL data requested");*/
		for(j = 0; j < 2; j++)
		{
			if(switches->adxl_on == 1)
			{
				if(switches->debug == 1)	print_ii_sci1(sio->adxl_data[j]);
				else						print_ii_sci2(sio->adxl_data[j]);
			}
			else
			{
				if(switches->debug == 1)	print_ii_sci1(0);
				else						print_ii_sci2(0);
			}
		}
	}

	/*ADXL202̒f[^ԑM*/
	if(sio->command == 'D')
	{
		for(j = 0; j < 2; j++)
		{
			if(switches->adxl_on == 1)
			{
				if(switches->debug == 1)	print_ii_sci1(sio->adxl_newtral[j]);
				else						print_ii_sci2(sio->adxl_newtral[j]);
			}
			else
			{
				if(switches->debug == 1)	print_ii_sci1(0);
				else						print_ii_sci2(0);
			}
		}
	}

	/*g`f[^PC󂯎*/
	if(sio->command == 'E')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		ram1 = sio->ram0_arm;
		do{
			if(switches->debug == 1)	ii = read_ii_sci1();
			else						ii = read_ii_sci2();

			if(ii < 9999) *ram1 = ii;
			ram1++;
		}while(ii != 9999);/*9999IR[h*/

		/*eg`f[^̃f[^PC󂯎*/
		switches->wave_datsum = 0;
		do{
			if(switches->debug == 1)	ii = read_ii_sci1();
			else						ii = read_ii_sci2();

			if(ii < 9999)
			{
				sio->wave_datnum[switches->wave_datsum] = ii;
				switches->wave_datsum++;
			}
		}while(ii != 9999);/*9999IR[h*/

		/*|C^CjVCY*/
		sio->wave_ptr[0] = sio->ram0_arm;
		for(j = 1; j < switches->wave_datsum; j++)
		{
			sio->wave_ptr[j] = sio->wave_ptr[j - 1] + sio->wave_datnum[j - 1] * 8;
		}

		/*ĐJnʒu擪Ɉړ*/
		sio->ram1_arm = sio->ram0_arm;
	}

	/*s铮g`ԍf[^PC󂯎*/
	if(sio->command == 'F')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*R}h͂PoCg*/
		if(switches->debug == 1)
		{
			j = (unsigned char)read_i_sci1();
		}
		else
		{
			j = read_c_sci2();
		}

		sio->ram1_arm = sio->wave_ptr[j];
		switches->wave_play_arm = sio->wave_datnum[j];
	}

	/*Ɠ̂̓R}hf[^󂯎*/
	if(sio->command == 'G')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*R}h*/
		if(switches->debug == 1)
		{
			servo_data_body->mode = (unsigned char)read_i_sci1();
			for(j = 0; j < 3; j++) action_com[j] = (unsigned char)read_i_sci1();
			servo_data_body->data_num = (unsigned char)read_i_sci1();
		}
		else
		{
			servo_data_body->mode = read_c_sci2();
			for(j = 0; j < 3; j++) action_com[j] = read_c_sci2();
			servo_data_body->data_num = read_c_sci2();
		}

		/*ƍ𓮂*/
		move_head(action_com, sio, servo_data_body);
	}

	/*Xe[^X|[g*/
	if(sio->command == 'H')
	{
		if(servo_data_arm->data_num > 1 || servo_data_body->data_num > 1
			|| switches->live_play_arm_v > 1 || switches->live_play_arm_h > 1)
		{
			/*g`Đ*/
			if(switches->debug == 1)	print_c_sci1(1);
			else						print_c_sci2(1);
		}
		else
		{
			/*ҋ@*/
			if(switches->debug == 1)	print_c_sci1(0);
			else						print_c_sci2(0);
		}
	}

	/*r𓮂*/
	if(sio->command == 'I')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*I@H:iz[hj@V:iグj*/
		if(switches->debug == 1)	j = read_c_sci1();
		else						j = read_c_sci2();

		/*1 or 0 󂯎*/
		/*V & 1: rグ*/
		/*H & 1: rL*/
		if(switches->debug == 1)	switches->live_dir_arm = (unsigned char)read_i_sci1();
		else						switches->live_dir_arm = (unsigned char)read_c_sci2();

		/*ڕW̎󂯎if[^j*/
		/*Eɂ̂܂܏oBɂ͕]*/
		if(switches->debug == 1)	jj = read_ii_sci1() / (unsigned int)10;
		else						jj = read_ii_sci2() / (unsigned int)10;

		if(j == 'V')
			switches->live_play_arm_v = (unsigned char)jj;
		else
			switches->live_play_arm_h = (unsigned char)jj;
	}

	/*̃^b`ZT񑗐M*/
	if(sio->command == 'J')
	{
		if(switches->debug == 1)	print_c_sci1(P4DR.BYTE);
		else						print_c_sci2(P4DR.BYTE);
	}

	/*RCT[{̐Mnm^nee*/
	if(sio->command == 'K')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/**/
		if(switches->debug == 1)	j = read_c_sci1();
		else						j = read_c_sci2();

		if(j == 1)	switches->servo_on = 1;
		else		switches->servo_on = 0;
	}

	/*̂̊֐߂RCT[{ݒlM*/
	if(sio->command == 'L')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*R}h͕KUoCg*/
		if(switches->debug == 1)
		{
			for(j = 0; j < 6; j++) sio_buff_i[j] = read_ii_sci1();
		}
		else
		{
			for(j = 0; j < 6; j++) sio_buff_i[j] = read_ii_sci2();
		}

		for(i = 0; i < 3; i++)
		{
			sio->body_newtral[i]	= (float)sio_buff_i[i];
			/*1000{l󂯎Bۂ̐ĺ@23.00O*/
			sio->body_propo_val[i]	= (float)sio_buff_i[i + 3] / 1000;
		}
	}

	/*dr̓d|[g*/
	if(sio->command == 'M')
	{
		AD.CSR.BIT.ADF = 0;
		while(AD.CSR.BIT.ADF == 0);
		i = (unsigned char)(AD.DRA / 256);

		/*
		print_i_sci1(i);
		*/
		if(switches->debug == 1)	print_c_sci1(i);
		else						print_c_sci2(i);
	}

	/*xZT@ʒu|[g*/
	if(sio->command == 'N')
	{
		if(switches->debug == 1)
		{
			for(i = 0; i < 2; i++) print_ii_sci1(sio->adxl_newtral[i]);
		}
		else
		{
			for(i = 0; i < 2; i++) print_ii_sci2(sio->adxl_newtral[i]);
		}
	}

	/*r֐߃f[^󂯎iP|CgA蓮j*/
	if(sio->command == 'O')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*[hR}h*/
		if(switches->debug == 1)	servo_data_arm->mode = (unsigned char)read_i_sci1();
		else						servo_data_arm->mode = read_c_sci2();

		/*ڕWf[^*/
		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < 4; i++)
			{
				if(switches->debug == 1)	servo_data_arm->data1[i][j] = read_ii_sci1();
				else						servo_data_arm->data1[i][j] = read_ii_sci2();
			}
		}

		/*|Cg*/
		if(switches->debug == 1)	servo_data_arm->data_num = (unsigned char)read_i_sci1();
		else						servo_data_arm->data_num = read_c_sci2();

		/*ep[^ݒ*/
		move_servo(servo_data_arm);
	}

	/*r֐߃f[^󂯎iP|CgA蓮j*/
	if(sio->command == 'P')
	{
		/*M*/
		comm_acc(switches->debug, sio->command);

		/*[hR}h*/
		if(switches->debug == 1)	servo_data_body->mode = (unsigned char)read_i_sci1();
		else						servo_data_body->mode = read_c_sci2();

		/*ڕWf[^*/
		if(switches->debug == 1)
		{
			servo_data_body->data1[0][0] = read_ii_sci1();
			servo_data_body->data1[0][1] = read_ii_sci1();
			servo_data_body->data1[1][1] = read_ii_sci1();
		}
		else
		{
			servo_data_body->data1[0][0] = read_ii_sci2();
			servo_data_body->data1[0][1] = read_ii_sci2();
			servo_data_body->data1[1][1] = read_ii_sci2();
		}

		/*|Cg*/
		if(switches->debug == 1)	servo_data_body->data_num = (unsigned char)read_i_sci1();
		else						servo_data_body->data_num = read_c_sci2();

		/*ep[^ݒ*/
		move_servo(servo_data_body);
	}

	/*r̂qbT[{@o͒̃f[^|[g*/
	if(sio->command == 'Q')
	{
		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < 4; i++)
			{
				if(switches->debug == 1)	print_ii_sci1(servo_data_arm->data1[i][j]);
				else						print_ii_sci2(servo_data_arm->data1[i][j]);
			}
		}
	}

	/*@mDQTubot̃eXgR}h@*/
	if(sio->command == '9')
	{
		/******************************/
		/******************************/
		/*R}h*/
		servo_data_body->mode = 1;

		/*ڕWf[^*/
		for(j = 0; j < 2; j++)
		{
			for(i = 0; i < 2; i++)
			{
				/*servo_data_arm->data1[i][j] = 3150;*/
				servo_data_body->data1[i][j] = 3150;
			}
		}

		/*|Cg*/
		servo_data_body->data_num = 50;

		/******************************/
		/******************************/
		move_servo(servo_data_body);
	}
	return(0);
}
